import { useRef } from 'react';
import { useAsync, useMount } from '@react-devui/hooks';
import { cloneHTMLElement } from '../../utils';
export function DAlertPopover(props) {
    const { children, dDuration, dEscClosable, onClose } = props;
    const dataRef = useRef({});
    const async = useAsync();
    useMount(() => {
        if (dDuration > 0) {
            dataRef.current.clearTid = async.setTimeout(() => {
                onClose === null || onClose === void 0 ? void 0 : onClose();
            }, dDuration * 1000);
        }
    });
    return children({
        render: (el) => {
            var _a, _b;
            return cloneHTMLElement(el, {
                tabIndex: (_a = el.props.tabIndex) !== null && _a !== void 0 ? _a : -1,
                role: (_b = el.props.role) !== null && _b !== void 0 ? _b : 'alert',
                onMouseEnter: (e) => {
                    var _a, _b, _c, _d;
                    (_b = (_a = el.props).onMouseEnter) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                    (_d = (_c = dataRef.current).clearTid) === null || _d === void 0 ? void 0 : _d.call(_c);
                },
                onMouseLeave: (e) => {
                    var _a, _b;
                    (_b = (_a = el.props).onMouseLeave) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                    if (dDuration > 0) {
                        dataRef.current.clearTid = async.setTimeout(() => {
                            onClose === null || onClose === void 0 ? void 0 : onClose();
                        }, dDuration * 1000);
                    }
                },
                onKeyDown: (e) => {
                    var _a, _b, _c, _d;
                    (_b = (_a = el.props).onKeyDown) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                    if (dEscClosable && e.code === 'Escape') {
                        (_d = (_c = dataRef.current).clearTid) === null || _d === void 0 ? void 0 : _d.call(_c);
                        onClose === null || onClose === void 0 ? void 0 : onClose();
                    }
                },
            });
        },
    });
}
